#import "WebinstatsPlugin.h"
@import iOS_wis;

@implementation WebinstatsPlugin

FlutterMethodChannel* channel;

Webinstats *webinstats = NULL;

BOOL didInvokeCalled;

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    channel = [FlutterMethodChannel
               methodChannelWithName:@"webinstats"
               binaryMessenger:[registrar messenger]];
    WebinstatsPlugin* instance = [[WebinstatsPlugin alloc] init];
    [registrar addMethodCallDelegate:instance channel:channel];
}



- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    if ([@"getPlatformVersion" isEqualToString:call.method]) {
        //        [ channel invokeMethod:@"pushClicked" arguments:@"hi"];
        result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
    } else if([@"addItem" isEqualToString:call.method]) {
        [self addItem:call.arguments[@"companyId"] domain:call.arguments[@"domain"] productId:call.arguments[@"productId"] domain:call.arguments[@"quantity"] domain:call.arguments[@"price"] domain:call.arguments[@"category"] domain:call.arguments[@"title"]];
    } else if([@"execute" isEqualToString:call.method]) {
        [self execute:call.arguments];
    } else if([@"createEvent" isEqualToString:call.method]) {
        [self createEvent:call.arguments[@"companyId"] domain:call.arguments[@"domain"] eventName:call.arguments[@"eventName"] eventMap:call.arguments];
    } else {
        result(FlutterMethodNotImplemented);
    }
}

- (void) execute:(NSDictionary*)map {
    
    @try {
        
        NSString *s = @"";
        NSString *domain = @"";
        s = [map valueForKey:@"s"];
        domain = [map valueForKey:@"domain"];
        if([s isEqualToString:@""]){
            return;
        }
        if ([domain isEqualToString:@""]) {
            domain = @"//wis.webinstats.com";
        }
//        [map setValue:@"React-Native" forKey:@"_wis_plt"];
//        [map setValue:@"1" forKey:@"_enable_push"];
        //resolve([[[HelloWorld alloc]init]testReactWithMap:map]);
        //   [[[Webinstats alloc]init:_cburl :s :@"0" ]sendPageviewWithLocalmap:map];
        //resolve([[[Webinstats alloc]init:@"//wis.webinstats.com" :s :@"0" ]testReactWithMap:map]);
        __weak typeof(self) weakSelf = self;
        
        dispatch_async(dispatch_get_main_queue(), ^{
            UIViewController *rootViewController = [UIApplication sharedApplication].delegate.window.rootViewController;
            
            
            if(webinstats == NULL){
                webinstats =  [[Webinstats alloc] init:domain :s :@"0"];
            }
//            NSLog(@"webinstats instance %@", webinstats);
            [webinstats executeWithView:rootViewController localmap:map];
        });
        
    }
    @catch (NSException *exception) {
        // reject(@"090033", @"Hata", exception);
    }
    
}

- (void) addItem:(NSString *)companyId
          domain:(NSString *)domain
       productId:(NSString *)productId
          domain:(NSString *)quantity
          domain:(NSString *)price
          domain:(NSString *)category
          domain:(NSString *)title{
    if([companyId isEqualToString:@""]){
        return;
    }
    if ([domain isEqualToString:@""]) {
        domain = @"//wis.webinstats.com";
    }
    if(webinstats == NULL){
        webinstats =  [[Webinstats alloc] init:domain :companyId :@"0"];
    }
    [webinstats addItemWithProductId:productId quantity:quantity price:price category:category title:title];
    
}

- (void) createEvent:(NSString *)companyId
              domain:(NSString *)domain
           eventName:(NSString *)eventName
            eventMap:(NSDictionary *)eventMap{
    if([companyId isEqualToString:@""]){
        return;
    }
    if ([domain isEqualToString:@""]) {
        domain = @"//wis.webinstats.com";
    }
    if(webinstats == NULL){
        webinstats =  [[Webinstats alloc] init:domain :companyId :@"0"];
    }
    
    
    UIViewController *rootViewController = [UIApplication sharedApplication].delegate.window.rootViewController;

    [webinstats createEventWithEventname:eventName view:rootViewController client_map:eventMap];
    
}




@end
