import 'dart:developer';
import 'package:flutter/services.dart';

class Webinstats {
  static const MethodChannel _channel = MethodChannel('webinstats');

  static void createEvent(
    String companyId,
    String domain,
    String eventName,
    Map<String, dynamic> map,
  ) {
    try {
      _channel.invokeMethod('createEvent', {
        ...map,
        'companyId': companyId,
        'domain': domain,
        "eventName": eventName,
        's': companyId,
      });
    } on PlatformException catch (e) {
      log(e.message ?? 'Oops... createEvent method facing an error!');
    }
  }

  static void addItem(
    String companyId,
    String domain,
    String productId,
    String quantity,
    String price,
    String category,
    String title,
  ) async {
    try {
      _channel.invokeMethod('addItem', {
        "companyId": companyId,
        "domain": domain,
        'productId': productId,
        "quantity": quantity,
        "price": price,
        "category": category,
        "title": title,
        's': companyId,
      });
    } on PlatformException catch (e) {
      log(e.message ?? 'Oops... addItem method facing an error!');
    }
  }

  static void execute(
    String companyId,
    String domain,
    Map<String, dynamic> map,
  ) async {
    try {
      _channel.invokeMethod('execute', {
        ...map,
        'companyId': companyId,
        'domain': domain,
        's': companyId,
      });
    } on PlatformException catch (e) {
      log(e.message ?? 'Oops... execute method facing an error!');
    }
  }
}
